#include <iostream>

using namespace std;

const int max2 = 30;
const int maxn = 60005;
const int mod = 998244353;

long long pw[max2 + 5];

long long dp[maxn][max2 + 5];
long long p[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    pw[0] = 1LL;
    pw[1] = 1LL;

    for (int i = 2; i <= max2; ++i)
    {
        pw[i] = 2LL * pw[i - 1];
    }

    for (int i = 0; i <= maxn - 5; ++i)
    {
        for (int j = 0; j <= max2; ++j)
        {
            dp[i][j] = -1;
        }
    }

    for (int i = 0; i <= max2; ++i)
    {
        dp[0][i] = 1;
    }

    for (long long i = 1; i <= 60000; ++i)
    {
        p[i] = p[i - 1];

        for (int j = 1; j <= max2; ++j)
        {
            if (i < pw[j])
            {
                break;
            }

            long long res = 0;

            for (long long d = 1; d <= 2; ++d)
            {
                if (i >= d * pw[j])
                {
                    //cout << "here for " << d << " " << dp[i - d * pw[j]][j - 1] << ", " << i - d * pw[j] << endl;

                    int nw = i - d * pw[j];

                    if (j == 1 || nw == 0)
                    {
                        if (j == 1 && nw != 0)
                        {
                            continue;
                        }

                        res++;

                        if (res >= mod)
                        {
                            res -= mod;
                        }

                        dp[i][j] = res;

                        continue;
                    }

                    for (int k = j - 1; k >= 1; --k)
                    {
                        if (dp[nw][k] == -1)
                        {
                            continue;
                        }

                        res += dp[nw][k];
                    }

                    if (res >= mod)
                    {
                        res -= mod;
                    }
                }
            }

            dp[i][j] = res;

            if (dp[i][j] != -1)
            {
                //cout << i << ' ' << j << ' ' << dp[i][j] << endl;
                p[i] += dp[i][j];

                if (p[i] >= mod)
                {
                    p[i] -= mod;
                }
            }
        }
    }

    int q;
    cin >> q;

    while (q--)
    {
        int l, r;
        cin >> l >> r;

        long long ans = p[r] - p[l - 1];

        if (ans < 0)
        {
            ans += mod;
        }

        cout << ans << "\n";
    }

    return 0;
}
