#include <bits/stdc++.h>
using namespace std;
unordered_map<string, int> init;
vector<int> G[100007];
int tryReuse[100007];
vector<int> reorder;
int visited[100007];

void output(int node, vector<int>::iterator b4){
    if(visited[node] != 0){ return; }
    visited[node] = reorder.size();
    for(vector<int>::iterator nxt = b4; nxt != reorder.end(); nxt++){
        visited[*nxt]++;
    }
    reorder.insert(b4, node);
    for(int i = 0; i < G[node].size(); i++){
        int next = G[node][i];
        if(next == tryReuse[node]){ continue; }
        output(next, reorder.end());
    }
    if(tryReuse[node] != 0){
        output(tryReuse[node], reorder.end());
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    reorder.push_back(-1);

    int n;
    cin >> n;
    int root = -1;
    vector<int> otherRoots;
    for(int i = 1; i <= n; i++){
        string op;
        int vars;
        cin >> op >> vars;
        vector<string> v(vars);
        for(int j = 0; j < vars; j++){
            cin >> v[j];
        }
        vector<string>::iterator it = v.begin();
        if(op == "set"){
            if(vars > 1){
                int initRow = init.find(v[1])->second;
//                if(tryReuse[initRow] != 0){
//                    cout << "HANDLE ME!\n"; /// TODO
//                    cout << "\trow #" << i << '\n';
//                    return -1;
//                }
                tryReuse[initRow] = i;
            }
            init.insert({v[0], i});
            ++it;
            if(vars == 1){
                if(root == -1){
                    root = i;
                }else{
                    otherRoots.push_back(i);
                }
            }
        }
        for(; it != v.end(); ++it){
            int initRow = init.find(*it)->second;
            G[initRow].push_back(i);
        }
    }

    output(root, reorder.end());
//    for(int i = 1; i < reorder.size(); i++){
//        cout << reorder[i];
//        if(i+1 < reorder.size()){
//            cout << ' ';
//        }
//    }
//    cout << '\n';

//    cout << "Left: \n";
    for(int other : otherRoots){
//        cout << other << '\n';
        int mn = INT_MAX;
        for(int child : G[other]){
//            cout << "\tbefore " << child << ": " << visited[child] << '\n';
            if(visited[child] < mn){
                mn = visited[child];
            }
        }
        int idx;
        for(idx = 1; idx <= mn; idx++){
            if(reorder[idx] > other){ break; }
        }
//        cout << "inserting at #" << idx << '\n';
        output(other, reorder.begin() + idx);

    }

    /// check TryReuse
//    for(int i = 0; i < )

    for(int i = 1; i < reorder.size(); i++){
        cout << reorder[i];
        if(i+1 < reorder.size()){
            cout << ' ';
        }
    }
    cout << '\n';
}
