#include <bits/stdc++.h>
using namespace std;

const long MOD=998244353, MAX_R=10000+1;
int Q;
long a[MAX_R];
long prefix[MAX_R];
vector<int> bin_nums;
queue<pair<int, int>> q;

void find_bin_nums()
{
    int x=1;

    while(x<MAX_R)
    {
        bin_nums.push_back(x);
        x*=2;
    }
}

long long calc_in_bobi_binary(int x)
{
    long c=0;
    q.push({0, 0});

    while(!q.empty())
    {
        pair<int, int> t=q.front();
        q.pop();

        if(t.first+bin_nums[t.second]==x)
        {
            c++;
        }

        if(t.first+2*bin_nums[t.second]==x)
        {
            c++;
        }

        if(t.first+bin_nums[t.second]<x)
        {
            q.push({t.first+bin_nums[t.second], t.second+1});
        }

        if(t.first+2*bin_nums[t.second]<x)
        {
            q.push({t.first+2*bin_nums[t.second], t.second+1});
        }

        if(t.first+bin_nums[t.second+1]<=x)
        {
            q.push({t.first, t.second+1});
        }
    }

    return c;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    find_bin_nums();
    q.push({0, 0});

    while(!q.empty())
    {
        pair<int, int> t=q.front();
        q.pop();

        if(t.first+bin_nums[t.second]<MAX_R)
        {
            a[t.first+bin_nums[t.second]]++;
            q.push({t.first+bin_nums[t.second], t.second+1});
        }

        if(t.first+2*bin_nums[t.second]<MAX_R)
        {
            a[t.first+2*bin_nums[t.second]]++;
            q.push({t.first+2*bin_nums[t.second], t.second+1});
        }

        if(t.first+bin_nums[t.second+1]<=MAX_R)
        {
            q.push({t.first, t.second+1});
        }
    }

    for(int i=1; i<=MAX_R; i++)
    {
        prefix[i]=prefix[i-1]+a[i];
    }


    cin >> Q;

    while(Q--)
    {
        long long l, r;
        cin >> l >> r;

        cout << prefix[r]-prefix[l-1]%MOD << '\n';
    }

    return 0;
}

