#include <bits/stdc++.h>

using namespace std;

const int maxn = 10;

int n;

vector<int> rows[maxn + 10];

map<string, int> decode;

int curr_code = 0;

int code(string& s)
{
    if (decode.find(s) != decode.end())
    {
        return decode[s];
    }

    return decode[s] = ++curr_code;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        string com;
        cin >> com;

        rows[i].push_back(code(com));

        int k;
        cin >> k;

        while (k--)
        {
            string s;
            cin >> s;

            rows[i].push_back(code(s));
        }
    }

    vector<int> p;

    for (int i = 1; i <= n; ++i)
    {
        p.push_back(i);
    }

    for (int i = 1; i <= 100; ++i)
    {
        random_shuffle(p.begin(), p.end());
    }

    for (auto x : p)
    {
        cout << x << " ";
    }

    cout << endl;

    return 0;
}
