#include<bits/stdc++.h>
using namespace std;

const long long MAX_N = 1e8;
const long long MAX_Q = 1e5 + 10;
const long long MOD = 998244353;

long long dp[MAX_N];
long long prefix[MAX_N];

long long q;
pair<long long, long long> inp[MAX_Q];

long long fromTroichna (const string& s) {
    long long ans = 0, mult = 1;
    for (long long i = s.size() - 1; i >= 0; i --) {
        ans += (s[i] - '0') * mult;
        mult *= 3;
    }
    return ans;
}

void toDvoichna (long long num, string& s) {
    if (num == 0) s = "0";
    while (num != 0) {
        s += (num % 2) + '0';
        num /= 2;
    }
    reverse(s.begin(), s.end());
    return;
}


    vector<string> checked;
long long answer (const string& s) {
    long long test = fromTroichna(s);
    if (dp[test] != 0) {
        return dp[test];
    }
    long long ans = 1;
    //cout << "-------- " << s << " --------" << endl;
    for (long long i = 0; i < s.size() - 1; i ++) {
        if (s[i] == '1' && s[i + 1] == '0') {
            string newS = s;
            newS[i] = '0';
            newS[i + 1] = '2';
            bool toCheck = true;
            for (int i = 0; i < checked.size() && toCheck; i++) {
                if (newS == checked[i]) {
                    toCheck = false;
                    break;
                }
            }
            if (!toCheck) continue;
            checked.push_back(newS);

            long long b = answer(newS);
            ans += b;
            ///cout << "\t(1) [" << i << " - " << s[i] << "(" << s << ")] " << newS << " - " << b << endl;
        } else if (s[i] == '2' && s[i + 1] == '0') {
            string newS = s;
            newS[i] = '1';
            newS[i + 1] = '2';


            bool toCheck = true;
            for (int i = 0; i < checked.size() && toCheck; i++) {
                if (newS == checked[i]) {
                    toCheck = false;
                    break;
                }
            }
            if (!toCheck) continue;
            checked.push_back(newS);

            long long b = answer(newS);
            ans += b;
            ///cout << "\t(2) [" << i << " - " << s[i] << "(" << s << ")] " << newS << " - " << b << endl;
        }
    }
    dp[test] = ans;
    return ans;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long maxNeed = 0;
    cin >> q;
    for (int i = 0; i < q; i++) {
        long long a, b;
        cin >> a >> b;
        inp[i] = {a, b};
        maxNeed = max(maxNeed, b);
    }
    prefix[0] = answer("0");
    for (int i = 1; i <= maxNeed; i ++) {
        string s;
        toDvoichna(i, s);
        prefix[i] = (prefix[i - 1] + answer(s)) % MOD;
    }

    for (int i = 0; i < q; i++) {
        cout << prefix[inp[i].second] - prefix[inp[i].first - 1] << endl;
    }



    return 0;
}


/*
0 = 1
1 = 1
2 = 2
3 = 1
4 = 3
5 = 2
6 = 3
7 = 1
8 = 4
9 = 3
10 = 5
11 = 2
12 = 5
13 = 3
14 = 4
15 = 1
16 = 5
17 = 4
18 = 7
19 = 3
20 = 8
21 = 5
*/
