#include <bits/stdc++.h>
using namespace std;

string s, n="";
stack<pair<int, char>> st;
int L=0, R=0;
int act_L=0, act_R=0;
int max_bracket=0;

void read()
{
    cin >> s;
}

void precalc()
{
    for(int i=0; i<s.size(); i++)
    {
        if(s[i]=='(')
        {
            st.push({s[i], 1});
        }
        else
        {
            if(!st.empty() && st.top().first=='(')
            {
                int curr=(i-st.top().second+1)/2;
                max_bracket=max(max_bracket, curr);
                st.pop();
            }
            else
            {
                st.push({s[i], 1});
            }
        }
    }

    while(!st.empty())
    {
        n+=st.top().first;
        st.pop();
    }

    reverse(n.begin(), n.end());
}

void check()
{
    cout << n << '\n';
}

void find_brackets()
{
    for(int i=0; i<n.size(); i++)
    {
        if(n[i]=='(')
        {
            act_R++;
            L++;
        }
        else
        {
            act_L++;
            R++;
        }
    }
}

void solve()
{
    cout << max_bracket << " " << max(L, R);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    precalc();
    find_brackets();
    ///check();
    solve();
    return 0;
}
