#include <bits/stdc++.h>
using namespace std;

string s;
stack<pair<int, char>> st;
vector<pair<int, char>> v;
char MAX[200001], MIN[200001];

void read()
{
    cin >> s;
}

void precalc()
{
    for(int i=0; i<s.size(); i++)
    {
        if(s[i]=='(')
        {
            st.push({s[i], i});
        }
        else
        {
            if(!st.empty() && st.top().first=='(')
            {
                st.pop();
            }
            else
            {
                st.push({s[i], i});
            }
        }
    }

    while(!st.empty())
    {
        v.push_back(st.top());
        st.pop();
    }

    reverse(v.begin(), v.end());
}

void check()
{
    for(int i=0; i<v.size(); i++)
    {
        cout << v[i].first << " " << v[i].second << '\n';
    }
}

void fill_MIN()
{
    for(int i=0; i<s.size()+v.size(); i++)
    {
        MIN[i]='0';
    }

    for(int i=0; i<v.size(); i++)
    {
        if(v[i].first=='(')
        {
            MIN[i+v[i].second+1]=')';
        }
        else
        {
            MIN[i+v[i].second]='(';
        }
    }

    int idx=0;

    for(int i=0; i<s.size()+v.size(); i++)
    {
        if(MIN[i]=='0')
        {
            MIN[i]=s[idx];
            idx++;
        }
    }
}

void fill_MAX()
{
    for(int i=0; i<s.size()+v.size(); i++)
    {
        MAX[i]='0';
    }

    int a=0, b=s.size()+v.size()-1;

    for(int i=0; i<v.size(); i++)
    {
        if(v[i].first=='(')
        {
            MAX[b]=')';
            b--;
        }
        else
        {
            MAX[a]='(';
            a++;
        }
    }

    int idx=0;

    for(int i=0; i<s.size()+v.size(); i++)
    {
        if(MAX[i]=='0')
        {
            MAX[i]=s[idx];
            idx++;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    precalc();
    fill_MIN();
    fill_MAX();
    ///check();

    int a=0, b=0;
    int curr=0;

    for(int i=0; i<s.size()+v.size(); i++)
    {
        if(MIN[i]=='(')
        {
            curr++;
        }
        else
        {
            a=max(a, curr);
            curr=0;
        }
    }

    a=max(a, curr);

    curr=0;

    for(int i=0; i<s.size()+v.size(); i++)
    {
        if(MAX[i]=='(')
        {
            curr++;
        }
        else
        {
            b=max(b, curr);
            curr=0;
        }
    }

    b=max(b, curr);

    cout << a << " " << b;
    return 0;
}
