#include <bits/stdc++.h>
using namespace std;

const int MAX_R=1000;
int Q;
int a[10*MAX_R+1];
int prefix[10*MAX_R+1];
vector<int> bin_nums;
queue<pair<int, int>> q;

void find_bin_nums()
{
    int x=1;

    while(x<=MAX_R)
    {
        bin_nums.push_back(x);
        x*=2;
    }

    bin_nums.push_back(x);
}

void gen(int x, int i)
{
    if(x>MAX_R)
    {
        return;
    }

    if(x+bin_nums[i]<=MAX_R)
    {
        a[x+bin_nums[i]]++;
        gen(x+bin_nums[i], i+1);
    }

    if(x+2*bin_nums[i]<=MAX_R)
    {
        a[x+2*bin_nums[i]]++;
        gen(x+2*bin_nums[i], i+1);
    }

    if(i+1!=bin_nums.size())
    {
        if(x+bin_nums[i+1]<=MAX_R)
        {
            gen(x, i+1);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    find_bin_nums();
    gen(0, 0);

    for(int i=1; i<=MAX_R; i++)
    {
        prefix[i]=prefix[i-1]+a[i];
    }


    cin >> Q;

    while(Q--)
    {
        int l, r;
        cin >> l >> r;

        cout << prefix[r]-prefix[l-1] << '\n';
    }

    return 0;
}

